Index: palm/trunk/SOURCE/data_output_module.f90
===================================================================
--- palm/trunk/SOURCE/data_output_module.f90	(revision 4146)
+++ palm/trunk/SOURCE/data_output_module.f90	(revision 4147)
@@ -759,165 +764,166 @@
 !>          ALLOCATE( u(<z>,<y>,<x>) )
 !--------------------------------------------------------------------------------------------------!
-FUNCTION dom_def_var( file_name, variable_name, dimension_names, output_type, is_global ) &
-            RESULT( return_value )
-
-   CHARACTER(LEN=*), INTENT(IN) ::  file_name      !< name of file
-   CHARACTER(LEN=*), INTENT(IN) ::  variable_name  !< name of variable
-   CHARACTER(LEN=*), INTENT(IN) ::  output_type    !< data type of variable
-
-   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_var'  !< name of this routine
-
-   CHARACTER(LEN=*), DIMENSION(:), INTENT(IN) ::  dimension_names  !< list of dimension names
-
-   INTEGER ::  d             !< loop index
-   INTEGER ::  f             !< loop index
-   INTEGER ::  i             !< loop index
-   INTEGER ::  nvars         !< number of variables in file
-   INTEGER ::  return_value  !< return value
-
-   LOGICAL                       ::  found      !< true if requested dimension is defined in file
-   LOGICAL, INTENT(IN), OPTIONAL ::  is_global  !< true if variable is global (same on all PE)
-
-   TYPE(variable_type)                            ::  variable       !< new variable
-   TYPE(variable_type), DIMENSION(:), ALLOCATABLE ::  variables_tmp  !< temporary variable list
-
-
-   return_value = 0
-   found = .FALSE.
-
-   CALL internal_message( 'debug', routine_name //                                     &
-                          ': define variable (variable "' // TRIM( variable_name ) //  &
-                          '", file "' // TRIM( file_name ) // '")' )
-
-   variable%name = TRIM( variable_name )
-
-   ALLOCATE( variable%dimension_names(SIZE( dimension_names )) )
-   ALLOCATE( variable%dimension_ids(SIZE( dimension_names )) )
-
-   variable%dimension_names = dimension_names
-   variable%dimension_ids = -1
-   variable%data_type = TRIM( output_type )
-
-   IF ( PRESENT( is_global ) )  THEN
-      variable%is_global = is_global
-   ELSE
-      variable%is_global = .FALSE.
-   ENDIF
-
-   !-- Add variable to database
-   DO  f = 1, nfiles
-
-      IF ( TRIM( file_name ) == files(f)%name )  THEN
-
-         IF ( files(f)%is_init )  THEN
-
-            return_value = 1
-            CALL internal_message( 'error', routine_name //                                  &
-                    ': file already initialized. No further variable definition allowed ' // &
-                    '(variable "' // TRIM( variable_name ) //                                &
-                    '", file "' // TRIM( file_name ) // '")!' )
-            EXIT
-
-         ELSEIF ( ALLOCATED( files(f)%dimensions ) )  THEN
-
-            !-- Check if any dimension of the same name as the new variable is already defined
-            DO  d = 1, SIZE( files(f)%dimensions )
-               IF ( files(f)%dimensions(d)%name == variable%name )  THEN
-                  return_value = 1
-                  CALL internal_message( 'error', routine_name //                    &
-                          ': file already has a dimension of this name defined. ' // &
-                          'Defining a variable of the same name is not allowed ' //  &
-                          '(variable "' // TRIM( variable_name ) //                  &
-                          '", file "' // TRIM( file_name ) // '")!' )
-                  EXIT
-               ENDIF
-            ENDDO
-
-            !-- Check if dimensions assigned to variable are defined within file
-            IF ( return_value == 0 )  THEN
-               DO  i = 1, SIZE( variable%dimension_names )
-                  found = .FALSE.
-                  DO  d = 1, SIZE( files(f)%dimensions )
-                     IF ( files(f)%dimensions(d)%name == variable%dimension_names(i) )  THEN
-                        found = .TRUE.
-                        EXIT
-                     ENDIF
-                  ENDDO
-                  IF ( .NOT. found )  THEN
-                     return_value = 1
-                     CALL internal_message( 'error', routine_name //                            &
-                             ': required dimension "'//  TRIM( variable%dimension_names(i) ) // &
-                             '" for variable is not defined ' //                                &
-                             '(variable "' // TRIM( variable_name ) //                          &
-                             '", file "' // TRIM( file_name ) // '")!' )
-                     EXIT
-                  ENDIF
-               ENDDO
-            ENDIF
-
-         ELSE
-
-            return_value = 1
-            CALL internal_message( 'error', routine_name //                      &
-                    ': no dimensions defined in file. Cannot define variable '// &
-                    '(variable "' // TRIM( variable_name ) //                    &
-                    '", file "' // TRIM( file_name ) // '")!' )
-
-         ENDIF
-
-         IF ( return_value == 0 )  THEN
-
-            !-- Check if variable already exists
-            IF ( .NOT. ALLOCATED( files(f)%variables ) )  THEN
-
-               nvars = 1
-               ALLOCATE( files(f)%variables(nvars) )
-
-            ELSE
-
-               nvars = SIZE( files(f)%variables )
-               DO  i = 1, nvars
-                  IF ( files(f)%variables(i)%name == variable%name )  THEN
-                     return_value = 1
-                     CALL internal_message( 'error', routine_name //   &
-                             ': variable already exists '//            &
-                             '(variable "' // TRIM( variable_name ) // &
-                             '", file "' // TRIM( file_name ) // '")!' )
-                     EXIT
-                  ENDIF
-               ENDDO
-
-               IF ( return_value == 0 )  THEN
-                  !-- Extend variable list
-                  ALLOCATE( variables_tmp(nvars) )
-                  variables_tmp = files(f)%variables
-                  DEALLOCATE( files(f)%variables )
-                  nvars = nvars + 1
-                  ALLOCATE( files(f)%variables(nvars) )
-                  files(f)%variables(:nvars-1) = variables_tmp
-                  DEALLOCATE( variables_tmp )
-               ENDIF
-
-            ENDIF
-
-            !-- Add new variable to database
-            IF ( return_value == 0 )  files(f)%variables(nvars) = variable
-
-         ENDIF
-
-         EXIT
-
-      ENDIF
-
-   ENDDO
-
-   IF ( f > nfiles )  THEN
-      return_value = 1
-      CALL internal_message( 'error', routine_name //                                   &
-                             ': file not found (variable "' // TRIM( variable_name ) // &
-                             '", file "' // TRIM( file_name ) // '")!' )
-   ENDIF
-
-END FUNCTION dom_def_var
+ FUNCTION dom_def_var( file_name, variable_name, dimension_names, output_type, is_global ) &
+             RESULT( return_value )
+
+    CHARACTER(LEN=*), INTENT(IN) ::  file_name      !< name of file
+    CHARACTER(LEN=*), INTENT(IN) ::  variable_name  !< name of variable
+    CHARACTER(LEN=*), INTENT(IN) ::  output_type    !< data type of variable
+
+    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_var'  !< name of this routine
+
+    CHARACTER(LEN=*), DIMENSION(:), INTENT(IN) ::  dimension_names  !< list of dimension names
+
+    INTEGER ::  d             !< loop index
+    INTEGER ::  f             !< loop index
+    INTEGER ::  i             !< loop index
+    INTEGER ::  nvars         !< number of variables in file
+    INTEGER ::  return_value  !< return value
+
+    LOGICAL                       ::  found      !< true if requested dimension is defined in file
+    LOGICAL, INTENT(IN), OPTIONAL ::  is_global  !< true if variable is global (same on all PE)
+
+    TYPE(variable_type)                            ::  variable       !< new variable
+    TYPE(variable_type), DIMENSION(:), ALLOCATABLE ::  variables_tmp  !< temporary variable list
+
+
+    return_value = 0
+    found = .FALSE.
+
+    CALL internal_message( 'debug', routine_name //                                     &
+                           ': define variable (variable "' // TRIM( variable_name ) //  &
+                           '", file "' // TRIM( file_name ) // '")' )
+
+    variable%name = TRIM( variable_name )
+
+    ALLOCATE( variable%dimension_names(SIZE( dimension_names )) )
+    ALLOCATE( variable%dimension_ids(SIZE( dimension_names )) )
+
+    variable%dimension_names = dimension_names
+    variable%dimension_ids = -1
+    variable%data_type = TRIM( output_type )
+
+    IF ( PRESENT( is_global ) )  THEN
+       variable%is_global = is_global
+    ELSE
+       variable%is_global = .FALSE.
+    ENDIF
+!
+!-- Add variable to database
+    DO  f = 1, nfiles
+
+       IF ( TRIM( file_name ) == files(f)%name )  THEN
+
+          IF ( files(f)%is_init )  THEN
+
+             return_value = 1
+             CALL internal_message( 'error', routine_name //                                  &
+                     ': file already initialized. No further variable definition allowed ' // &
+                     '(variable "' // TRIM( variable_name ) //                                &
+                     '", file "' // TRIM( file_name ) // '")!' )
+             EXIT
+
+          ELSEIF ( ALLOCATED( files(f)%dimensions ) )  THEN
+!
+!--          Check if any dimension of the same name as the new variable is already defined
+             DO  d = 1, SIZE( files(f)%dimensions )
+                IF ( files(f)%dimensions(d)%name == variable%name )  THEN
+                   return_value = 1
+                   CALL internal_message( 'error', routine_name //                    &
+                           ': file already has a dimension of this name defined. ' // &
+                           'Defining a variable of the same name is not allowed ' //  &
+                           '(variable "' // TRIM( variable_name ) //                  &
+                           '", file "' // TRIM( file_name ) // '")!' )
+                   EXIT
+                ENDIF
+             ENDDO
+!
+!--          Check if dimensions assigned to variable are defined within file
+             IF ( return_value == 0 )  THEN
+                DO  i = 1, SIZE( variable%dimension_names )
+                   found = .FALSE.
+                   DO  d = 1, SIZE( files(f)%dimensions )
+                      IF ( files(f)%dimensions(d)%name == variable%dimension_names(i) )  THEN
+                         found = .TRUE.
+                         EXIT
+                      ENDIF
+                   ENDDO
+                   IF ( .NOT. found )  THEN
+                      return_value = 1
+                      CALL internal_message( 'error', routine_name //                            &
+                              ': required dimension "'//  TRIM( variable%dimension_names(i) ) // &
+                              '" for variable is not defined ' //                                &
+                              '(variable "' // TRIM( variable_name ) //                          &
+                              '", file "' // TRIM( file_name ) // '")!' )
+                      EXIT
+                   ENDIF
+                ENDDO
+             ENDIF
+
+          ELSE
+
+             return_value = 1
+             CALL internal_message( 'error', routine_name //                      &
+                     ': no dimensions defined in file. Cannot define variable '// &
+                     '(variable "' // TRIM( variable_name ) //                    &
+                     '", file "' // TRIM( file_name ) // '")!' )
+
+          ENDIF
+
+          IF ( return_value == 0 )  THEN
+!
+!--          Check if variable already exists
+             IF ( .NOT. ALLOCATED( files(f)%variables ) )  THEN
+
+                nvars = 1
+                ALLOCATE( files(f)%variables(nvars) )
+
+             ELSE
+
+                nvars = SIZE( files(f)%variables )
+                DO  i = 1, nvars
+                   IF ( files(f)%variables(i)%name == variable%name )  THEN
+                      return_value = 1
+                      CALL internal_message( 'error', routine_name //   &
+                              ': variable already exists '//            &
+                              '(variable "' // TRIM( variable_name ) // &
+                              '", file "' // TRIM( file_name ) // '")!' )
+                      EXIT
+                   ENDIF
+                ENDDO
+
+                IF ( return_value == 0 )  THEN
+!
+!--                Extend variable list
+                   ALLOCATE( variables_tmp(nvars) )
+                   variables_tmp = files(f)%variables
+                   DEALLOCATE( files(f)%variables )
+                   nvars = nvars + 1
+                   ALLOCATE( files(f)%variables(nvars) )
+                   files(f)%variables(:nvars-1) = variables_tmp
+                   DEALLOCATE( variables_tmp )
+                ENDIF
+
+             ENDIF
+!
+!--          Add new variable to database
+             IF ( return_value == 0 )  files(f)%variables(nvars) = variable
+
+          ENDIF
+
+          EXIT
+
+       ENDIF
+
+    ENDDO
+
+    IF ( f > nfiles )  THEN
+       return_value = 1
+       CALL internal_message( 'error', routine_name //                                   &
+                              ': file not found (variable "' // TRIM( variable_name ) // &
+                              '", file "' // TRIM( file_name ) // '")!' )
+    ENDIF
+
+ END FUNCTION dom_def_var
 
 !--------------------------------------------------------------------------------------------------!
@@ -946,46 +952,46 @@
 !>                   value=' and this part was appended', append=.TRUE. )
 !--------------------------------------------------------------------------------------------------!
-FUNCTION dom_def_att_char( file_name, variable_name, attribute_name, value, append ) &
-            RESULT( return_value )
-
-   CHARACTER(LEN=*),      INTENT(IN)           ::  file_name               !< name of file
-   CHARACTER(LEN=*),      INTENT(IN)           ::  attribute_name          !< name of attribute
-   CHARACTER(LEN=*),      INTENT(IN)           ::  value                   !< attribute value
-   CHARACTER(LEN=*),      INTENT(IN), OPTIONAL ::  variable_name           !< name of variable
-   CHARACTER(LEN=charlen)                      ::  variable_name_internal  !< internal copy of variable_name
-
-   ! CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_att_char'  !< name of routine
-
-   INTEGER ::  return_value  !< return value
-
-   LOGICAL                       ::  append_internal  !< same as 'append'
-   LOGICAL, INTENT(IN), OPTIONAL ::  append           !< if true, append value to existing value
-
-   TYPE(attribute_type) ::  attribute  !< new attribute
-
-
-   return_value = 0
-
-   IF ( PRESENT( append ) )  THEN
-      append_internal = append
-   ELSE
-      append_internal = .FALSE.
-   ENDIF
-
-   attribute%name       = TRIM( attribute_name )
-   attribute%data_type  = 'char'
-   attribute%value_char = TRIM( value )
-
-   IF ( PRESENT( variable_name ) )  THEN
-      variable_name_internal = TRIM( variable_name )
-   ELSE
-      variable_name_internal = ''
-   ENDIF
-
-   return_value = save_attribute_in_database( file_name=TRIM( file_name ), &
-                     variable_name=TRIM( variable_name_internal ),         &
-                     attribute=attribute, append=append_internal )
-
-END FUNCTION dom_def_att_char
+ FUNCTION dom_def_att_char( file_name, variable_name, attribute_name, value, append ) &
+             RESULT( return_value )
+
+    CHARACTER(LEN=*),      INTENT(IN)           ::  file_name               !< name of file
+    CHARACTER(LEN=*),      INTENT(IN)           ::  attribute_name          !< name of attribute
+    CHARACTER(LEN=*),      INTENT(IN)           ::  value                   !< attribute value
+    CHARACTER(LEN=*),      INTENT(IN), OPTIONAL ::  variable_name           !< name of variable
+    CHARACTER(LEN=charlen)                      ::  variable_name_internal  !< internal copy of variable_name
+
+    ! CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_att_char'  !< name of routine
+
+    INTEGER ::  return_value  !< return value
+
+    LOGICAL                       ::  append_internal  !< same as 'append'
+    LOGICAL, INTENT(IN), OPTIONAL ::  append           !< if true, append value to existing value
+
+    TYPE(attribute_type) ::  attribute  !< new attribute
+
+
+    return_value = 0
+
+    IF ( PRESENT( append ) )  THEN
+       append_internal = append
+    ELSE
+       append_internal = .FALSE.
+    ENDIF
+
+    attribute%name       = TRIM( attribute_name )
+    attribute%data_type  = 'char'
+    attribute%value_char = TRIM( value )
+
+    IF ( PRESENT( variable_name ) )  THEN
+       variable_name_internal = TRIM( variable_name )
+    ELSE
+       variable_name_internal = ''
+    ENDIF
+
+    return_value = save_attribute_in_database( file_name=TRIM( file_name ), &
+                      variable_name=TRIM( variable_name_internal ),         &
+                      attribute=attribute, append=append_internal )
+
+ END FUNCTION dom_def_att_char
 
 !--------------------------------------------------------------------------------------------------!
@@ -1008,56 +1014,56 @@
 !>                   value=1_1 )
 !--------------------------------------------------------------------------------------------------!
-FUNCTION dom_def_att_int8( file_name, variable_name, attribute_name, value, append ) &
-            RESULT( return_value )
-
-   CHARACTER(LEN=*),      INTENT(IN)           ::  file_name               !< name of file
-   CHARACTER(LEN=*),      INTENT(IN)           ::  attribute_name          !< name of attribute
-   CHARACTER(LEN=*),      INTENT(IN), OPTIONAL ::  variable_name           !< name of variable
-   CHARACTER(LEN=charlen)                      ::  variable_name_internal  !< internal copy of variable_name
-
-   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_att_int8'  !< name of routine
-
-   INTEGER(KIND=1), INTENT(IN) ::  value  !< attribute value
-
-   INTEGER ::  return_value  !< return value
-
-   LOGICAL                       ::  append_internal  !< same as 'append'
-   LOGICAL, INTENT(IN), OPTIONAL ::  append           !< if true, append value to existing value
-
-   TYPE(attribute_type) ::  attribute  !< new attribute
-
-
-   return_value = 0
-
-   IF ( PRESENT( variable_name ) )  THEN
-      variable_name_internal = TRIM( variable_name )
-   ELSE
-      variable_name_internal = ''
-   ENDIF
-
-   IF ( PRESENT( append ) )  THEN
-      IF ( append )  THEN
-         return_value = 1
-         CALL internal_message( 'error', routine_name //                             &
-                                ': numeric attribute cannot be appended ' //         &
-                                '(attribute "' // TRIM( attribute_name ) //          &
-                                '", variable "' // TRIM( variable_name_internal ) // &
-                                '", file "' // TRIM( file_name ) // '")!' )
-      ENDIF
-   ENDIF
-
-   IF ( return_value == 0 )  THEN
-      append_internal = .FALSE.
-
-      attribute%name       = TRIM( attribute_name )
-      attribute%data_type  = 'int8'
-      attribute%value_int8 = value
-
-      return_value = save_attribute_in_database( file_name=TRIM( file_name ), &
-                        variable_name=TRIM( variable_name_internal ),         &
-                        attribute=attribute, append=append_internal )
-   ENDIF
-
-END FUNCTION dom_def_att_int8
+ FUNCTION dom_def_att_int8( file_name, variable_name, attribute_name, value, append ) &
+             RESULT( return_value )
+
+    CHARACTER(LEN=*),      INTENT(IN)           ::  file_name               !< name of file
+    CHARACTER(LEN=*),      INTENT(IN)           ::  attribute_name          !< name of attribute
+    CHARACTER(LEN=*),      INTENT(IN), OPTIONAL ::  variable_name           !< name of variable
+    CHARACTER(LEN=charlen)                      ::  variable_name_internal  !< internal copy of variable_name
+
+    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_att_int8'  !< name of routine
+
+    INTEGER(KIND=1), INTENT(IN) ::  value  !< attribute value
+
+    INTEGER ::  return_value  !< return value
+
+    LOGICAL                       ::  append_internal  !< same as 'append'
+    LOGICAL, INTENT(IN), OPTIONAL ::  append           !< if true, append value to existing value
+
+    TYPE(attribute_type) ::  attribute  !< new attribute
+
+
+    return_value = 0
+
+    IF ( PRESENT( variable_name ) )  THEN
+       variable_name_internal = TRIM( variable_name )
+    ELSE
+       variable_name_internal = ''
+    ENDIF
+
+    IF ( PRESENT( append ) )  THEN
+       IF ( append )  THEN
+          return_value = 1
+          CALL internal_message( 'error', routine_name //                             &
+                                 ': numeric attribute cannot be appended ' //         &
+                                 '(attribute "' // TRIM( attribute_name ) //          &
+                                 '", variable "' // TRIM( variable_name_internal ) // &
+                                 '", file "' // TRIM( file_name ) // '")!' )
+       ENDIF
+    ENDIF
+
+    IF ( return_value == 0 )  THEN
+       append_internal = .FALSE.
+
+       attribute%name       = TRIM( attribute_name )
+       attribute%data_type  = 'int8'
+       attribute%value_int8 = value
+
+       return_value = save_attribute_in_database( file_name=TRIM( file_name ), &
+                         variable_name=TRIM( variable_name_internal ),         &
+                         attribute=attribute, append=append_internal )
+    ENDIF
+
+ END FUNCTION dom_def_att_int8
 
 !--------------------------------------------------------------------------------------------------!
@@ -1080,56 +1086,56 @@
 !>                   value=1_2 )
 !--------------------------------------------------------------------------------------------------!
-FUNCTION dom_def_att_int16( file_name, variable_name, attribute_name, value, append ) &
-            RESULT( return_value )
-
-   CHARACTER(LEN=*),      INTENT(IN)           ::  file_name               !< name of file
-   CHARACTER(LEN=*),      INTENT(IN)           ::  attribute_name          !< name of attribute
-   CHARACTER(LEN=*),      INTENT(IN), OPTIONAL ::  variable_name           !< name of variable
-   CHARACTER(LEN=charlen)                      ::  variable_name_internal  !< internal copy of variable_name
-
-   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_att_int16'  !< name of routine
-
-   INTEGER(KIND=2), INTENT(IN) ::  value  !< attribute value
-
-   INTEGER ::  return_value  !< return value
-
-   LOGICAL                       ::  append_internal  !< same as 'append'
-   LOGICAL, INTENT(IN), OPTIONAL ::  append           !< if true, append value to existing value
-
-   TYPE(attribute_type) ::  attribute  !< new attribute
-
-
-   return_value = 0
-
-   IF ( PRESENT( variable_name ) )  THEN
-      variable_name_internal = TRIM( variable_name )
-   ELSE
-      variable_name_internal = ''
-   ENDIF
-
-   IF ( PRESENT( append ) )  THEN
-      IF ( append )  THEN
-         return_value = 1
-         CALL internal_message( 'error', routine_name //                             &
-                                ': numeric attribute cannot be appended ' //         &
-                                '(attribute "' // TRIM( attribute_name ) //          &
-                                '", variable "' // TRIM( variable_name_internal ) // &
-                                '", file "' // TRIM( file_name ) // '")!' )
-      ENDIF
-   ENDIF
-
-   IF ( return_value == 0 )  THEN
-      append_internal = .FALSE.
-
-      attribute%name        = TRIM( attribute_name )
-      attribute%data_type   = 'int16'
-      attribute%value_int16 = value
-
-      return_value = save_attribute_in_database( file_name=TRIM( file_name ), &
-                        variable_name=TRIM( variable_name_internal ),         &
-                        attribute=attribute, append=append_internal )
-   ENDIF
-
-END FUNCTION dom_def_att_int16
+ FUNCTION dom_def_att_int16( file_name, variable_name, attribute_name, value, append ) &
+             RESULT( return_value )
+
+    CHARACTER(LEN=*),      INTENT(IN)           ::  file_name               !< name of file
+    CHARACTER(LEN=*),      INTENT(IN)           ::  attribute_name          !< name of attribute
+    CHARACTER(LEN=*),      INTENT(IN), OPTIONAL ::  variable_name           !< name of variable
+    CHARACTER(LEN=charlen)                      ::  variable_name_internal  !< internal copy of variable_name
+
+    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_att_int16'  !< name of routine
+
+    INTEGER(KIND=2), INTENT(IN) ::  value  !< attribute value
+
+    INTEGER ::  return_value  !< return value
+
+    LOGICAL                       ::  append_internal  !< same as 'append'
+    LOGICAL, INTENT(IN), OPTIONAL ::  append           !< if true, append value to existing value
+
+    TYPE(attribute_type) ::  attribute  !< new attribute
+
+
+    return_value = 0
+
+    IF ( PRESENT( variable_name ) )  THEN
+       variable_name_internal = TRIM( variable_name )
+    ELSE
+       variable_name_internal = ''
+    ENDIF
+
+    IF ( PRESENT( append ) )  THEN
+       IF ( append )  THEN
+          return_value = 1
+          CALL internal_message( 'error', routine_name //                             &
+                                 ': numeric attribute cannot be appended ' //         &
+                                 '(attribute "' // TRIM( attribute_name ) //          &
+                                 '", variable "' // TRIM( variable_name_internal ) // &
+                                 '", file "' // TRIM( file_name ) // '")!' )
+       ENDIF
+    ENDIF
+
+    IF ( return_value == 0 )  THEN
+       append_internal = .FALSE.
+
+       attribute%name        = TRIM( attribute_name )
+       attribute%data_type   = 'int16'
+       attribute%value_int16 = value
+
+       return_value = save_attribute_in_database( file_name=TRIM( file_name ), &
+                         variable_name=TRIM( variable_name_internal ),         &
+                         attribute=attribute, append=append_internal )
+    ENDIF
+
+ END FUNCTION dom_def_att_int16
 
 !--------------------------------------------------------------------------------------------------!
@@ -1152,56 +1158,56 @@
 !>                   value=1_4 )
 !--------------------------------------------------------------------------------------------------!
-FUNCTION dom_def_att_int32( file_name, variable_name, attribute_name, value, append ) &
-            RESULT( return_value )
-
-   CHARACTER(LEN=*),      INTENT(IN)           ::  file_name               !< name of file
-   CHARACTER(LEN=*),      INTENT(IN)           ::  attribute_name          !< name of attribute
-   CHARACTER(LEN=*),      INTENT(IN), OPTIONAL ::  variable_name           !< name of variable
-   CHARACTER(LEN=charlen)                      ::  variable_name_internal  !< internal copy of variable_name
-
-   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_att_int32'  !< name of routine
-
-   INTEGER(KIND=4), INTENT(IN) ::  value  !< attribute value
-
-   INTEGER ::  return_value  !< return value
-
-   LOGICAL                       ::  append_internal  !< same as 'append'
-   LOGICAL, INTENT(IN), OPTIONAL ::  append           !< if true, append value to existing value
-
-   TYPE(attribute_type) ::  attribute  !< new attribute
-
-
-   return_value = 0
-
-   IF ( PRESENT( variable_name ) )  THEN
-      variable_name_internal = TRIM( variable_name )
-   ELSE
-      variable_name_internal = ''
-   ENDIF
-
-   IF ( PRESENT( append ) )  THEN
-      IF ( append )  THEN
-         return_value = 1
-         CALL internal_message( 'error', routine_name //                             &
-                                ': numeric attribute cannot be appended ' //         &
-                                '(attribute "' // TRIM( attribute_name ) //          &
-                                '", variable "' // TRIM( variable_name_internal ) // &
-                                '", file "' // TRIM( file_name ) // '")!' )
-      ENDIF
-   ENDIF
-
-   IF ( return_value == 0 )  THEN
-      append_internal = .FALSE.
-
-      attribute%name        = TRIM( attribute_name )
-      attribute%data_type   = 'int32'
-      attribute%value_int32 = value
-
-      return_value = save_attribute_in_database( file_name=TRIM( file_name ), &
-                        variable_name=TRIM( variable_name_internal ),         &
-                        attribute=attribute, append=append_internal )
-   ENDIF
-
-END FUNCTION dom_def_att_int32
+ FUNCTION dom_def_att_int32( file_name, variable_name, attribute_name, value, append ) &
+             RESULT( return_value )
+
+    CHARACTER(LEN=*),      INTENT(IN)           ::  file_name               !< name of file
+    CHARACTER(LEN=*),      INTENT(IN)           ::  attribute_name          !< name of attribute
+    CHARACTER(LEN=*),      INTENT(IN), OPTIONAL ::  variable_name           !< name of variable
+    CHARACTER(LEN=charlen)                      ::  variable_name_internal  !< internal copy of variable_name
+
+    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_att_int32'  !< name of routine
+
+    INTEGER(KIND=4), INTENT(IN) ::  value  !< attribute value
+
+    INTEGER ::  return_value  !< return value
+
+    LOGICAL                       ::  append_internal  !< same as 'append'
+    LOGICAL, INTENT(IN), OPTIONAL ::  append           !< if true, append value to existing value
+
+    TYPE(attribute_type) ::  attribute  !< new attribute
+
+
+    return_value = 0
+
+    IF ( PRESENT( variable_name ) )  THEN
+       variable_name_internal = TRIM( variable_name )
+    ELSE
+       variable_name_internal = ''
+    ENDIF
+
+    IF ( PRESENT( append ) )  THEN
+       IF ( append )  THEN
+          return_value = 1
+          CALL internal_message( 'error', routine_name //                             &
+                                 ': numeric attribute cannot be appended ' //         &
+                                 '(attribute "' // TRIM( attribute_name ) //          &
+                                 '", variable "' // TRIM( variable_name_internal ) // &
+                                 '", file "' // TRIM( file_name ) // '")!' )
+       ENDIF
+    ENDIF
+
+    IF ( return_value == 0 )  THEN
+       append_internal = .FALSE.
+
+       attribute%name        = TRIM( attribute_name )
+       attribute%data_type   = 'int32'
+       attribute%value_int32 = value
+
+       return_value = save_attribute_in_database( file_name=TRIM( file_name ), &
+                         variable_name=TRIM( variable_name_internal ),         &
+                         attribute=attribute, append=append_internal )
+    ENDIF
+
+ END FUNCTION dom_def_att_int32
 
 !--------------------------------------------------------------------------------------------------!
